<?php

if ( ! defined( 'ABSPATH' ) ) {	exit; }

trait OSMaps_admin{

    static function osmaps_register_setting(){
        global $OSM;
        register_setting( $OSM->name, $OSM->name, [ 'OSMaps_admin', 'Validate_form' ] );
    }
    
    
    static function add_submenu_page() {
        add_options_page( 'OSMaps', 'OSMaps', 'manage_options', plugin_basename(__FILE__), [ 'OSMaps_admin', 'display_admin_page' ] );
    }
    
    
    static function load_admin_external() {
        global $OSM;        $deps = [];
        
        wp_register_style( 'OSMadminStyle', $OSM->dirURL . 'public/osmAdmin.css', $deps, null );
        wp_enqueue_style( 'OSMadminStyle' );
    }
    
     
    static function display_admin_page(){
        global $OSM;    global $osmaps_db_options;
        
//        $all_options = base64_encode(json_encode($osmaps_db_options, JSON_HEX_TAG));
        $all_options = json_encode($osmaps_db_options, JSON_HEX_TAG|JSON_HEX_QUOT|JSON_HEX_APOS);
        
    /*  form action url    */
        $url = admin_url( 'options.php' );

    /*  translations */
        $DET = new stdClass();
        $DET->lon = __( '<span>- Longitude</span>. A positive (East) or negative (West) floating point number. Ex: 10.36581', 'osmapsWP' );
        $DET->lat = __( '<span>- Latitude</span>. A positive (Nord) or negative (South) floating point number. Ex: 45.3980', 'osmapsWP' );
        $DET->hCo = __( '<span>- Help</span>. <a href="https://wpd.edilweb.eu/maps_findCoordinates/" target="_blank"> Help for coordinates </a>', 'osmapsWP' );
        $DET->zoo = __( '<span>- Zoom</span>. A positive integer number. Ex: 16', 'osmapsWP' );
        $DET->pop = __( '<span>- PopUp</span>. Your message. In plain text or text/html format.<br>  &nbsp;Caution. Your html tags could take an existing style from the theme.', 'osmapsWP' );
        $DET->hei = __( '<span>- Height</span>. Format #px. Ex: 400px', 'osmapsWP' );
        $DET->max = __( '<span>- Max-width</span>. Optional. An empty setting will make the image full width. Format #px. Ex: 360px', 'osmapsWP' );
        
        $lon  = __( 'Longitude', 'osmapsWP' );               $lonT = __( 'Longitude float value', 'osmapsWP' );
        $lat  = __( 'Latitude', 'osmapsWP' );                $latT = __( 'Latitude float value', 'osmapsWP' );
        $zomT = __('integer value', 'osmapsWP');
        
        $mty = __( 'Map type', 'osmapsWP' );        
        $OP = new stdClass();
        $OP->s  = __( 'Simple', 'osmapsWP' );
        $OP->m  = __( 'with Marker', 'osmapsWP' );
        $OP->p  = __( 'with PopUp', 'osmapsWP' );
        $OP->mp = __( 'with Marker and PopUp', 'osmapsWP' );
        
        $txt = __( 'Your<br>popup text', 'osmapsWP' );       $txh = __( 'HTML allowed', 'osmapsWP' );
        
        $hgt = __( 'Height', 'osmapsWP' );                   $hgtT = __( 'Height. Ex: 330px', 'osmapsWP' );                                         
        $max = __( 'Max-width', 'osmapsWP' );                $maxT = __( 'Max-width. Ex: 400px', 'osmapsWP' );
        
        $wdi = __( 'Disable wheel', 'osmapsWP' );            $wdiT = __( 'Disable wheel by default', 'osmapsWP' );
        
        $un5 = __( 'error #5: unknown error in SELECT', 'osmapsWP' );
        $un6 = __( 'error #6: unknown error in SELECT', 'osmapsWP' );
        $un7 = __( 'No empty Map!', 'osmapsWP' );
        $un8 = __( 'Double map name Error!', 'osmapsWP' );
        $un9 = __( 'Delete map -', 'osmapsWP' );            $un91 = __( '- Are you sure?', 'osmapsWP' );
        
        $MP = new stdClass();
        $MP->a   = __( 'All Maps', 'osmapsWP' );
        $MP->s   = __( 'Selected map', 'osmapsWP' );
        $MP->v   = __( 'Maps available', 'osmapsWP' );
        $MP->n   = __( 'Add New Map', 'osmapsWP' );
        $MP->nm  = __( 'Name Map', 'osmapsWP' );
        $MP->nt  = __( 'Your new map. Es: MyNewMap', 'osmapsWP' );
        $MP->ba  = __( 'Add new Map', 'osmapsWP' );
        $MP->ym  = __( 'Map name', 'osmapsWP' );
        $MP->adw = __( 'Click Save Changes for a definitive registration.', 'osmapsWP' );

    /*  
     * look /plugins/OSMaps/public/expanded/OSMaps_setting.php     
     * for this expanded code   
     */
        $a = <<<STG
<div class="wrap">    
<h1>OSMaps Settings <span class="spanVers">&nbsp; ver.&nbsp;{$osmaps_db_options['version']}</span></h1>
                
<div class="option-page-wrap">
<h2 class="nav-tab-wrapper">
<a class="nav-tab" id="wpt_allMaps_tab" href="#wpt-allMaps">{$MP->a}</a>
<a class="nav-tab" id="wpt_selMap_tab" href="#wpt-selMap">{$MP->s}</a>
</h2> 
            
<form id="useless_form" action=""></form>
<form action="{$url}" method="post" id="osmaps_form">
STG;
        echo $a;
    
    /* Output nonce, action, and option_page fields for my settings page.    */
        settings_fields( $OSM->name );
    
        $aa = <<<STG
<div class="tab-content-wrapper">
<input id="Ser2Bro" name="{$OSM->name}" type="hidden" value='{$all_options}'>
<input id="ShortDefault" type="hidden" value="{$OSM->shortcode}">

<section id="wpt_allMaps" class="tab-content">
<h3 class="wp-heading-inline">{$MP->v}</h3>
<details id="OSMaddMap" class="OSMadminDetail">
<summary>{$MP->n}</summary>
<p>
<label class="newMapLabel" for="new_map">{$MP->nm}</label>
<input type="text" id="new_map" title="{$MP->nt}" form="useless_form" pattern="^[a-zA-Z0-9_]*$">
<input type="submit" form="useless_form" value="{$MP->ba}">
</p>
</details>
<div id="add_del_warning" class="osmMsgGreen">
<p><strong>{$MP->adw}</strong></p>
</div>
<table class="wp-list-table widefat">
<thead>
<tr>
<td id="cb" class="manage-column">
<label class="screen-reader-text">Seleziona</label>
</td>
<th scope="col" id="name" class="manage-column column-name">{$MP->ym}</th>
<th scope="col" id="delete" class="manage-column column-delete">Delete</th>
<th scope="col" id="shCode" class="manage-column column-shortcode">ShortCode</th>
</tr>
</thead>
<tbody id="the-list">
<tr>
<th scope="row" class="check-column">
<label class="screen-reader-text">Seleziona una mappa</label>
<input type="checkbox" id="mapDefault" data-id="mapDefault" checked onclick="OSMx.clickCheckbox(this);">
</th>
<td class="map column-map">
<strong>mapDefault</strong>
</td>
<td class="mapDelete column-mapDelete">
<strong> --- </strong>
</td>
<td class="mapShCode column-mapShCode">
<strong>[{$OSM->shortcode}]</strong>
</td>                
</tr>
</tbody>
</table>
</section>

<section id="wpt_selMap" class="tab-content">
<h3 class="wp-heading-inline">Selected map:<span id="osm_selected"></span></h3>
<details class="OSMadminDetail">
<p> {$DET->lon}</p>
<p> {$DET->lat}</p>
<p> {$DET->hCo}</p>
<p> {$DET->zoo}</p>
<p> {$DET->pop}</p>
<p> {$DET->hei}</p>
<p> {$DET->max}</p>
<hr>
</details>
<table class="form-table">
<tbody>
<tr>
<th scope="row">
<label class="OSrequi" for="longi_tude">{$lon} </label>
</th>
<td>
<input type="text" id="longi_tude" class="groupElementschange" pattern="[-+]?([0-9]*\.[0-9]+|[0-9]+)" title="{$lonT}" value="" required>
</td>
</tr>
<tr>
<th scope="row">
<label class="OSrequi" for="lati_tude">{$lat} </label>
</th>
<td>
<input type="text" id="lati_tude" class="groupElementschange" pattern="[-+]?([0-9]*\.[0-9]+|[0-9]+)" title="{$latT}" value="" required>
</td>
</tr>
<tr>
<th scope="row">
<label class="OSrequi" for="zo_om">Zoom </label>
</th>
<td>
<input type="number" id="zo_om" class="groupElementschange" title="{$zomT}" min="1" value="" required>
</td>
</tr>
<tr>
<th scope="row">
<label for="mp_type">{$mty} </label>
</th>
<td>
<select id="mp_type" class="groupElementschange">
<option value="1" >{$OP->s}</option> 
<option value="2">{$OP->m}</option>
<option value="3" >{$OP->p}</option>
<option value="5" >{$OP->mp} </option>
</select>  
</td>
</tr>
<tr id="hid_tr">
<th scope="row">
<label for="map_popup">{$txt} </label>
</th>
<td>
<textarea  id="map_popup" class="mappaPopup groupElementschange"></textarea><br><i>{$txh}</i>
</td>
</tr>
<tr><th scope="row">CSS</th><td>&nbsp;</td></tr>
<tr>
<th scope="row">
<label class="OSrequi" for="al_tezza">{$hgt} </label>
</th>
<td>
<input type="text" id="al_tezza" class="groupElementschange" pattern="^\d{1,4}(px)$" title="{$hgtT}"  value="" required>
</td>               
</tr>
<tr>
<th scope="row">
<label for="max_wtd">{$max} </label>
</th>
<td>
<input type="text" id="max_wtd" class="groupElementschange" pattern="^\d{1,4}(px)$" title="{$maxT}" value="">
</td>
</tr>
<tr>
<th scope="row">
<p><label for="no_wheel">{$wdi}</label></p>
</th>
<td>
<input type="checkbox" id="no_wheel" class="groupElementschange" title="{$wdiT}" >
</td>
</tr>
</tbody>
</table>
</section>
</div>
<p>
STG;
        echo $aa;    

    /*  Echoes a submit button  */
        submit_button();
                
        $aaa = <<<STG
</p>
</form>
</div>
                
<script>
(function(){var a = mp_type.options[mp_type.selectedIndex].value;switch(a){case '1':case '2':map_popup.disabled = true;hid_tr.style.visibility = 'hidden';break;
case '3':case '4':case '5':map_popup.disabled = false;hid_tr.style.visibility = 'visible';break;default:alert('{$un5}');break;}})();
var passiveSupported = false;
try {var options={get passive(){passiveSupported = true;}};window.addEventListener("test",options,options);window.removeEventListener("test",options,options);}catch(err){passiveSupported=false;}
mp_type.addEventListener('change',function(){var a = this.options[ this.selectedIndex ].value;switch(a){case '1':case '2':map_popup.disabled = true;hid_tr.style.visibility = 'hidden';break;case '3':case '4':case '5':map_popup.disabled = false;hid_tr.style.visibility = 'visible';break;default:alert('{$un6}');break;}},passiveSupported?{passive:true}:false);
</script>

<script>
function OSMsettingsJS(){                
    var AllSettings = {}; var ActiveMap; var EditedMap;

    this.edited = function(){return EditedMap = true;};

    this.displayAll = function(){ if( EditedMap ){SaveOptionsChanged();} wpt_selMap.style.display = 'none'; wpt_allMaps.style.display = 'block';};

    function SaveOptionsChanged(){ AllSettings[ActiveMap].longitude = longi_tude.value; AllSettings[ActiveMap].latitude = lati_tude.value; AllSettings[ActiveMap].zoom = zo_om.value; AllSettings[ActiveMap].mptype = mp_type.options[mp_type.selectedIndex].value; AllSettings[ActiveMap].mapopup = map_popup.value; AllSettings[ActiveMap].height = al_tezza.value; AllSettings[ActiveMap].maxwtd = max_wtd.value; AllSettings[ActiveMap].noWheel = no_wheel.checked; EditedMap = false; }

    this.displaySel = function(){ wpt_allMaps.style.display = 'none'; wpt_selMap.style.display = 'block'; ValueSelected();};                

    this.ParseSettings = function(){ AllSettings = JSON.parse(Ser2Bro.value); ActiveMap = 'mapDefault'; var MapsKey = Object.keys(AllSettings);
        MapsKey.forEach(function(item){ if(item === 'version') {return;} if(item === 'mapDefault') {return;} var genit = document.getElementById('the-list'), riga = document.createElement('tr'); riga.id = 'r_' + item; 
        riga.innerHTML='<th scope="row" class="check-column">'+'<label class="screen-reader-text">Seleziona una mappa</label>'+'<input type="checkbox" id="' + item + '" data-id="'+ item +'" onclick="OSMx.clickCheckbox(this);">'+'</th>'+'<td class="mapName column-mapName">'+'<strong>' + item + '</strong>'+'</td>'+'<td class="mapDelete column-mapDelete">'+'<strong><a id="a_' + item + '" href="" onclick="OSMx.deleteMap(this);">Delete</a></strong>'+'</td>'+'<td class="mapShCode column-mapShCode">'+'<strong>['+ ShortDefault.value + '&nbsp;id=' + '"'+ item + '"' + ']</strong>'+'</td>';
        genit.appendChild(riga);});};

    this.MySubmitForm = function(){ if( EditedMap === true){ AllSettings[ActiveMap].longitude = longi_tude.value; AllSettings[ActiveMap].latitude = lati_tude.value; AllSettings[ActiveMap].zoom = zo_om.value; AllSettings[ActiveMap].mptype = mp_type.options[mp_type.selectedIndex].value; AllSettings[ActiveMap].mapopup = map_popup.value; AllSettings[ActiveMap].height = al_tezza.value; AllSettings[ActiveMap].maxwtd = max_wtd.value; AllSettings[ActiveMap].noWheel = no_wheel.checked; } Ser2Bro.value = JSON.stringify(AllSettings); }; 

    this.AddNewMap = function(event){ event.preventDefault(); if(new_map.value === ''){ alert('{$un7}'); return;} var MapsKey = Object.keys(AllSettings); var nameError; MapsKey.forEach(function(item){ if(item === new_map.value){nameError = 1;alert('{$un8}');}}); if(nameError === 1) {return;}
        newMap={longitude: 0, latitude: 0, zoom: 18, mptype: 1, mapopup: '', height: '350px', maxwtd: '', noWheel: 'checked' }; AllSettings[new_map.value] = newMap;
        var genit = document.getElementById('the-list'), riga = document.createElement('tr'); riga.id = 'r_' + new_map.value;
        riga.innerHTML = '<th scope="row" class="check-column">'+'<label class="screen-reader-text">Seleziona una mappa</label>'+'<input type="checkbox" id="' + new_map.value + '" data-id="'+ new_map.value +'" onclick="OSMx.clickCheckbox(this);">'+'</th>'+'<td class="mapName column-mapName">'+'<strong>' + new_map.value + '</strong>'+'</td>'+'<td class="mapDelete column-mapDelete">'+'<strong><a id="a_' + new_map.value + '" href="" onclick="OSMx.deleteMap(this);">Delete</a></strong>'+'</td>'+'<td class="mapShCode column-mapShCode">'+'<strong>['+ ShortDefault.value + '&nbsp;id=' + '"'+ new_map.value + '"' + ']</strong>'+'</td>';genit.appendChild(riga);
        var cBox = document.querySelectorAll('[data-id]');cBox.forEach(function(item){if(item.id === new_map.value){item.checked = true; ActiveMap = item.id; ValueSelected()}else{item.checked = false;}});
        new_map.value = ''; OSMaddMap.removeAttribute("open"); add_del_warning.style = "visibility:visible";};

    this.clickCheckbox = function(box){ if(box.id === ActiveMap){ event.preventDefault(); }else{document.getElementById(ActiveMap).checked = false; ActiveMap = box.id; box.checked = true; ValueSelected();}};

    this.deleteMap = function(box){event.preventDefault();let mapToDelete = box.id.substring(2);var dlt = confirm('{$un9} '+ mapToDelete + ' {$un91}');if(dlt === false){return;}
        document.getElementById(ActiveMap).checked = false; delete AllSettings[mapToDelete]; document.getElementById('r_' + mapToDelete).remove(); ActiveMap = 'mapDefault'; document.getElementById(ActiveMap).checked = true; ValueSelected(); add_del_warning.style = "visibility:visible";};

    function ValueSelected (){osm_selected.innerHTML = ActiveMap;longi_tude.value = AllSettings[ActiveMap].longitude;lati_tude.value = AllSettings[ActiveMap].latitude;zo_om.value = AllSettings[ActiveMap].zoom;for(var i=0; i < mp_type.options.length; i++){if(mp_type.options[i].value === AllSettings[ActiveMap].mptype.toString()) { mp_type.options[i].selected = true;mapTypeTextarea(mp_type);}}map_popup.value = AllSettings[ActiveMap].mapopup;al_tezza.value = AllSettings[ActiveMap].height;max_wtd.value = AllSettings[ActiveMap].maxwtd;no_wheel.checked = AllSettings[ActiveMap].noWheel;}

    function mapTypeTextarea(cheType){var a = cheType.options[cheType.selectedIndex].value;switch (a){case '1':case '2':map_popup.disabled = true;hid_tr.style.visibility = 'hidden';break;case '3':case '4':case '5':map_popup.disabled = false;hid_tr.style.visibility = 'visible';break;default:alert( 'error #6: unknown error in popup' );break;}}
}

var OSMx = new OSMsettingsJS;  
document.addEventListener('DOMContentLoaded', ()=>{
        OSMx.ParseSettings();

        wpt_allMaps_tab.addEventListener('click', function(){ OSMx.displayAll(); });

        wpt_selMap_tab.addEventListener('click', function(){ OSMx.displaySel(); });

        osmaps_form.addEventListener('submit', function(){OSMx.MySubmitForm();});

        useless_form.addEventListener('submit', function(event){ OSMx.AddNewMap(event); });
        
        document.querySelectorAll('.groupElementschange').forEach(item => { item.addEventListener('change', (event)=> { OSMx.edited(); });  });
  });
</script>
</div>
STG;
        echo $aaa;       
    }
    
    
    static function Db_initial_values() {
         $a = [
             'version'=>'2.1.0', 
             'mapDefault' => ['longitude' => 12.338843,                        /*   float   */
                            'latitude' => 45.434302,                           /*  float   */
                            'zoom' => 18,                                      /*  integer */
                            'mptype' => 5,                                         /*  integer */
                            'mapopup' => 'San Marco Square <br>Venezia - Italy',   /*  text/html string  */
                            'height' => '350px',                                   /*  string  */
                            'maxwtd' => '',                                    /*  string  */
                            'noWheel' => 'checked'                      /*  default no wheel */
                 ]                       
             ];                                               
         return $a; 
    }
    

    static function Validate_form( $inputs ) {
        global $OSM;
        
        $decJSON = json_decode($inputs, true );
//        $decJSON = json_decode( base64_decode( $inputs ), true );

        foreach ( $decJSON as $key => $value ) {
            $valid = [];
            
            if( $key === 'version' ) { continue; }

            $valid['longitude'] = floatval( sanitize_text_field( $value['longitude'] ));
            $valid['latitude']  = floatval( sanitize_text_field( $value['latitude'] ));
            $valid['zoom']      = intval( sanitize_text_field( $value['zoom'] ));
            $valid['mptype']    = intval( sanitize_text_field( $value['mptype'] ));
            
            /*  popup visible or hidden */
            if(( $valid['mptype'] < 1 ) || ( $valid['mptype'] > 5 )) {            
                add_settings_error( $OSM->adminErr, $OSM->adminErr, __( 'OSMaps error #2: OSMaps_admin::Validate_form', 'osmapsWP' ) );
                $valid['mptype'] = 3;       /* OSMaps_admin::Db_initial_values()['mptype']; */
            }
            else {
                if(( 1 === $valid['mptype'] ) || ( 2 === $valid['mptype'] )){
                    $valid['mapopup'] = '';
                }
                else {
                    /*  sanitize and balance tags    */
                    $valid['mapopup'] = balanceTags( wp_kses_post( $value['mapopup'] ), true );
                }
            }


            $valid['height'] = sanitize_text_field( $value['height'] );    /* height   */
            if( !preg_match( '/^\d{1,4}(px)$/', $valid['height'] )){
                add_settings_error( $OSM->adminErr, $OSM->adminErr, __( 'OSMaps error #3: Height format example: 350px', 'osmapsWP' ));
                $valid['height']   = '350px';   /*  OSMaps_admin::Db_initial_values()['height'];    */
            }


            $valid['maxwtd'] = sanitize_text_field( $value['maxwtd'] );    /* width    */
            if( !empty($valid['maxwtd'] )){
                if( !preg_match( '/^\d{1,4}(px)$/', $valid['maxwtd'] )){
                    add_settings_error( $OSM->adminErr, $OSM->adminErr, __( 'OSMaps error #4: Max - Width format example: 500px', 'osmapsWP' ));
                    $valid['maxwtd'] = '';  /* OSMaps_admin::Db_initial_values()['maxwtd']; default */
                }
            }

            /* disable wheel    */
           ( isset( $value['noWheel'] ) && ($value['noWheel'] == true))  ? $valid['noWheel'] = 'checked' : $valid['noWheel'] = '';

            $decJSON[$key] = $valid;                
        }
  
        return $decJSON;
    }
    
    
    static function add_link_settings( $links ){
        $adminURL = admin_url( 'options-general.php?page=' . plugin_basename(__FILE__));
        
        $mylinks = [ '<a href="' . $adminURL . '">' . __( 'Settings', 'osmapsWP' ) . '</a>' ]; 
        
        return array_merge( $links, $mylinks );
    }
}