<?php

if ( ! defined( 'ABSPATH' ) ) {	exit; }

class GetDb_and_UpdateVersion{
    static $osmaps_db_options = [];
    
    function __construct( $OSM ) {
        /* get database options */
        $osmaps_db_options = get_option( $OSM->name );

        /* if the database options are empty, set the initial ones */
        if( ! $osmaps_db_options ){
            if( !class_exists('OSMaps_admin')){
                include 'class.admin.php';
            }

            $dbIni = OSMaps_admin::Db_initial_values();            
            add_option( $OSM->name, ( array )$dbIni );
            $osmaps_db_options = get_option( $OSM->name );
        }
        
        /*  update from 1.0.0 */
        if( !isset( $osmaps_db_options[ 'version' ] )){
            $db_up = [];

            $db_up[ 'version' ] = '2.1.0';          /*  add version */

            $db_up[ 'mapDefault' ] = $osmaps_db_options;    /*  add the old map */

            $db_up[ 'mapDefault' ]['noWheel'] = 'checked';      /*  add disable wheel   */

            update_option( $OSM->name, ( array )$db_up );
            $osmaps_db_options = get_option( $OSM->name );
        }
        
        /* update from 1.1.0  */
        if( $osmaps_db_options[ 'version' ] === '1.1.0' ){
            
            $osmaps_db_options[ 'version' ] = '2.1.0';                  /*  change version */

        }
        
        /* update to 2.1.0  */
        if( $osmaps_db_options[ 'version' ] === '2.0.0' ){
            $osmaps_db_options[ 'version' ] = '2.1.0';
        }
        
        self::$osmaps_db_options = $osmaps_db_options;
    }
}