<?php
/*
Plugin Name: OSMaps
Plugin URI: https://wpd.edilweb.eu
Description: It is a plugin which displays maps on your site. Source Tiles: OpenStreetMap. API javascript: OpenLayers.
Version: 2.1.0
Author: Alessandro Lin
Author URI:  https://wpd.edilweb.eu
License: GPL-2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.txt
Text Domain: osmapsWP
Domain Path: /languages
*/

/**
 * Copyright 2019 Alessandro Lin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {	exit; }

function activate_osmaps(){}

function deactivate_osmaps() {}

function add_action_link_osmaps( $links ) {
    $mylinks = [ '<a href="' . admin_url( 'options-general.php?page=osmaps_options' ) . '">' . __( 'Settings', 'osmapsWP' ) .'</a>' ];
    return array_merge( $links, $mylinks );
}
    
function osmaps_textdomain(){
    global $OSM;
    load_plugin_textdomain( $OSM->name, FALSE, ( dirname( plugin_basename( __FILE__ ) ) . '/languages' )); 
}


/* ******** */ 
/*   main   */
/* ******** */ 

$OSM = new stdClass;
$OSM->name = 'osmapsWP';
$OSM->dirURL = plugin_dir_url(__FILE__);    /*  http://localhost/wplocal.it/wp-content/plugins/OSMaps/  */
$OSM->shortcode = 'osmaps_display';         /*  [osmaps_display]    */
$OSM->adminErr = 'OSMadminError';

register_activation_hook( __FILE__, 'activate_osmaps' );
register_deactivation_hook( __FILE__, 'deactivate_osmaps' );

add_action( 'plugins_loaded', 'osmaps_textdomain' );

if( !class_exists( 'GetDb_and_UpdateVersion' )){
    include __DIR__ . '/icd/class.updateversion.php';    
}
new GetDb_and_UpdateVersion( $OSM );

/* @var $osmaps_db_options array. get database options */
$osmaps_db_options = GetDb_and_UpdateVersion::$osmaps_db_options;



if( is_admin() ){
    if( !trait_exists('OSMaps_admin')){
        include __DIR__ . '/icd/class.admin.php';
    }
    add_action( 'admin_init', 'OSMaps_admin::osmaps_register_setting' );  
    
    add_action( 'admin_menu', 'OSMaps_admin::add_submenu_page' );
    
    add_action('admin_enqueue_scripts', 'OSMaps_admin::load_admin_external');
    
    add_filter( 'plugin_action_links_'. plugin_basename(__FILE__), 'OSMaps_admin::add_link_settings' );
}
else{
    include __DIR__ . '/icd/class.frontend.php';
    
    new OSMaps_frontend( $OSM, $osmaps_db_options );    
}
